from re import match
from sys import stderr

def label(n,D,S): return ''.join( s for d,s in zip(D,S) if n%d==0 )

def solve(tokens):
    N = len(tokens)

    D = []
    S = []

    for n in range(N):
        is_number = match( r'^[0-9]*$', tokens[n] )
        is_string = match( r'^[a-z]*$', tokens[n] )

        if not is_number and not is_string: return n

        current_label = label(n+1,D,S)
        if current_label == '':
            # this should either be the current number, or it defines a new rule
            if is_number:
                if tokens[n] != str(n+1): return n
            else:
                if len( tokens[n] ) > 25: return n
                D.append( n+1 )
                S.append( tokens[n] )
        else:
            # this should either be the current label, or it should be the current label + a new rule
            if len( tokens[n] ) < len( current_label ): return n
            if tokens[n] == current_label: continue
            cll = len(current_label)
            if tokens[n][:cll] != current_label: return n
            new_label = tokens[n][cll:]
            if len( new_label ) > 25: return n
            D.append( n+1 )
            S.append( new_label )

    return N

T = int( input() )
for t in range(T):
    input()
    input()
    print( solve( input().split() ) )
